// #autoload
// #name = GrabTimer
// #category = ilys' Scripts

$GrabTimerSec = "0"@0;
$GrabTimerMin = "0"@0;
package GrabTimer
{
	function PlayGui::onWake( %this )
	{
		addMessageCallback('MsgCTFFlagTaken', handleGrabTimerTaken);
		addMessageCallback('MsgCTFFlagDropped', handleGrabTimerDropCap);
		addMessageCallback('MsgCTFFlagCapped', handleGrabTimerDropCap);
		parent::onWake( %this );

		if(!isObject(PlayGui)) return;
		
		if(isObject(GrabTimerHud)) return;

		new ShellFieldCtrl(GrabTimerHud)
		{
			profile = "GuiConsoleProfile";
			horizSizing = "left";
			vertSizing = "bottom";
			extent = "60 16";
			minExtent = "8 8";
			visible = "1";
			new GuiMLTextCtrl(GrabTimerHudtext) {
				profile = "ShellMediumTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "4 0";
				extent = "60 16 ";
				visible = "1";
			};
		};
		playGui.add(GrabTimerHud);

		GrabTimerHud.setVisible(false);
		GrabTimerHudtext.setValue(0);
		$GrabTimerSec = "0"@0;
		$GrabTimerMin = "0"@0;

		if(isObject(HM) && isObject(HudMover)) hudmover::addhud(GrabTimerHud,"GrabTimer");
	}

	function handleGrabTimerTaken(%msgType, %msgString, %clientName, %flagTeam, %flagTeamId, %clientNameBase)
	{
		error(%msgString);
		if(strstr(%msgString, "You took") != -1)
			DoTimer();
	}

	function handleGrabTimerDropCap(%msgType, %msgString, %clientName, %flagTeam, %flagTeamId, %clientNameBase)
	{
		error(%msgString);
		if(strstr(%msgString, "You dropped") != -1 || strstr(%msgString, "You captured") != -1)
		{
			if($GrabTimerSchedule !$= "") cancel($GrabTimerSchedule);
			schedule(2000, 0, ResetTimer);
		}
	}

	function DoTimer()
	{
		if(strLen($GrabTimerSec) == 1) $GrabTimerSec = "0"@$GrabTimerSec;
		if($GrabTimerSec == 60)
		{
			$GrabTimerSec = "0"@0;
			$GrabTimerMin++;
			if(strLen($GrabTimerMin) == 1) $GrabTimerMin = "0"@$GrabTimerMin;
		}
		$FlagTakenTime = $GrabTimerMin @ ":" @ $GrabTimerSec;
		GrabTimerHud.setVisible(true);
		GrabTimerHudtext.setValue($FlagTakenTime);
		if($GrabTimerSchedule !$= "") cancel($GrabTimerSchedule);
		$GrabTimerSchedule = schedule(1000, 0, DoTimer);
		$GrabTimerSec++;
	}

	function ResetTimer()
	{
		GrabTimerHud.setVisible(false);
		GrabTimerHudtext.setValue(0);
		$GrabTimerSec = "0"@0;
		$GrabTimerMin = "0"@0;
	}

	function DisconnectedCleanup(){
		if($GrabTimerSchedule !$= "") cancel($GrabTimerSchedule);
		GrabTimerHud.setVisible(false);
		GrabTimerHudtext.setValue(0);
		$GrabTimerSec = "0"@0;
		$GrabTimerMin = "0"@0;
		parent::DisconnectedCleanup();
	}
};
activatePackage(GrabTimer);